diff -Nur lwip/src/api/api_msg.c lwip-mcast/src/api/api_msg.c
--- lwip/src/api/api_msg.c	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/api/api_msg.c	Sat Jan 27 15:34:01 2018
@@ -165,9 +165,35 @@
 
       buf->p = q;
       buf->ptr = q;
-      ip_addr_copy(buf->addr, *ip_current_src_addr());
+      ip_addr_copy(buf->addr, *addr);
       buf->port = pcb->protocol;
 
+#if LWIP_NETBUF_RECVINFO
+      if (conn->flags & NETCONN_FLAG_PKTINFO) {
+        buf->flags = NETBUF_FLAG_DESTADDR;
+        /* If we use mroute this packet maybe a mroute fake packet so we must get ipv4/ipv6 header */
+        if (IP_IS_V4(addr)) {
+          struct ip_hdr *iphdr = (struct ip_hdr *)p->payload;
+          ip_addr_copy_from_ip4(buf->toaddr, iphdr->dest);
+        } else 
+#if LWIP_IPV6
+        {
+          struct ip6_hdr *ip6hdr = (struct ip6_hdr *)p->payload;
+          ip_addr_copy_from_ip6_packed(buf->toaddr, ip6hdr->dest);
+        }
+#endif /* LWIP_IPV6 */
+      }
+#if LWIP_IPV6
+      if (conn->flags & NETCONN_FLAG_HOPLIM) { /* IPV6_HOPLIMIT */
+        if (IP_IS_V6(addr)) {
+          struct ip6_hdr *ip6hdr = (struct ip6_hdr *)p->payload;
+          buf->flags |= NETBUF_FLAG_HOPLIM; /* IPV6_RECVHOPLIMIT (Hop limit) */
+          buf->hoplim = IP6H_HOPLIM(ip6hdr);
+        }
+      }
+#endif /* LWIP_IPV6 */
+#endif /* LWIP_NETBUF_RECVINFO */
+
       len = q->tot_len;
       if (sys_mbox_trypost(&conn->recvmbox, buf) != ERR_OK) {
         netbuf_delete(buf);
@@ -244,6 +270,15 @@
       ip_addr_set(&buf->toaddr, ip_current_dest_addr());
       buf->toport_chksum = udphdr->dest;
     }
+#if LWIP_IPV6
+    if (conn->flags & NETCONN_FLAG_HOPLIM) { /* IPV6_HOPLIMIT */
+      if (IP_IS_V6(addr)) {
+        struct ip6_hdr *ip6hdr = (struct ip6_hdr *)ip6_current_header();
+        buf->flags |= NETBUF_FLAG_HOPLIM; /* IPV6_RECVHOPLIMIT (Hop limit) */
+        buf->hoplim = IP6H_HOPLIM(ip6hdr);
+      }
+    }
+#endif /* LWIP_IPV6 */
 #endif /* LWIP_NETBUF_RECVINFO */
   }
 
@@ -1946,36 +1981,31 @@
 
   msg->err = ERR_CONN;
   if (msg->conn->pcb.tcp != NULL) {
+#if LWIP_IGMP || (LWIP_IPV6 && LWIP_IPV6_MLD)
     if (NETCONNTYPE_GROUP(msg->conn->type) == NETCONN_UDP) {
 #if LWIP_UDP
-#if LWIP_IPV6 && LWIP_IPV6_MLD
-      if (NETCONNTYPE_ISIPV6(msg->conn->type)) {
-        if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
-          msg->err = mld6_joingroup(ip_2_ip6(API_EXPR_REF(msg->msg.jl.netif_addr)),
-                                    ip_2_ip6(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        } else {
-          msg->err = mld6_leavegroup(ip_2_ip6(API_EXPR_REF(msg->msg.jl.netif_addr)),
-                                     ip_2_ip6(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        }
-      } else
-#endif /* LWIP_IPV6 && LWIP_IPV6_MLD */
-      {
-#if LWIP_IGMP
-        if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
-          msg->err = igmp_joingroup(ip_2_ip4(API_EXPR_REF(msg->msg.jl.netif_addr)),
-                                    ip_2_ip4(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        } else {
-          msg->err = igmp_leavegroup(ip_2_ip4(API_EXPR_REF(msg->msg.jl.netif_addr)),
-                                     ip_2_ip4(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        }
-#endif /* LWIP_IGMP */
+      if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
+        msg->err = mcast_join_group(&msg->conn->pcb.udp->ipmc, API_EXPR_REF(msg->msg.jl.netif_addr), API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
+      } else {
+        msg->err = mcast_leave_group(&msg->conn->pcb.udp->ipmc, API_EXPR_REF(msg->msg.jl.netif_addr), API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
       }
+#else
+      msg->err = ERR_VAL;
 #endif /* LWIP_UDP */
-#if (LWIP_TCP || LWIP_RAW)
+    } else if (NETCONNTYPE_GROUP(msg->conn->type) == NETCONN_RAW) {
+#if LWIP_RAW
+      if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
+        msg->err = mcast_join_group(&msg->conn->pcb.raw->ipmc, API_EXPR_REF(msg->msg.jl.netif_addr), API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
+      } else {
+        msg->err = mcast_leave_group(&msg->conn->pcb.raw->ipmc, API_EXPR_REF(msg->msg.jl.netif_addr), API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
+      }
+#else
+      msg->err = ERR_VAL;
+#endif /* LWIP_RAW */
     } else {
       msg->err = ERR_VAL;
-#endif /* (LWIP_TCP || LWIP_RAW) */
     }
+#endif /* LWIP_IGMP || (LWIP_IPV6 && LWIP_IPV6_MLD) */
   }
   TCPIP_APIMSG_ACK(msg);
 }
@@ -1999,36 +2029,31 @@
 
   msg->err = ERR_CONN;
   if (msg->conn->pcb.tcp != NULL) {
+#if LWIP_IGMP || (LWIP_IPV6 && LWIP_IPV6_MLD)
     if (NETCONNTYPE_GROUP(msg->conn->type) == NETCONN_UDP) {
 #if LWIP_UDP
-#if LWIP_IPV6 && LWIP_IPV6_MLD
-      if (NETCONNTYPE_ISIPV6(msg->conn->type)) {
-        if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
-          msg->err = mld6_joingroup_netif(netif,
-                                          ip_2_ip6(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        } else {
-          msg->err = mld6_leavegroup_netif(netif,
-                                           ip_2_ip6(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        }
-      } else
-#endif /* LWIP_IPV6 && LWIP_IPV6_MLD */
-      {
-#if LWIP_IGMP
-        if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
-          msg->err = igmp_joingroup_netif(netif,
-                                          ip_2_ip4(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        } else {
-          msg->err = igmp_leavegroup_netif(netif,
-                                           ip_2_ip4(API_EXPR_REF(msg->msg.jl.multiaddr)));
-        }
-#endif /* LWIP_IGMP */
+      if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
+        msg->err = mcast_join_netif(&msg->conn->pcb.udp->ipmc, netif, API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
+      } else {
+        msg->err = mcast_leave_netif(&msg->conn->pcb.udp->ipmc, netif, API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
       }
+#else
+      msg->err = ERR_VAL;
 #endif /* LWIP_UDP */
-#if (LWIP_TCP || LWIP_RAW)
+    } else if (NETCONNTYPE_GROUP(msg->conn->type) == NETCONN_RAW) {
+#if LWIP_RAW
+      if (msg->msg.jl.join_or_leave == NETCONN_JOIN) {
+        msg->err = mcast_join_netif(&msg->conn->pcb.raw->ipmc, netif, API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
+      } else {
+        msg->err = mcast_leave_netif(&msg->conn->pcb.raw->ipmc, netif, API_EXPR_REF(msg->msg.jl.multiaddr), NULL);
+      }
+#else
+      msg->err = ERR_VAL;
+#endif /* LWIP_RAW */
     } else {
       msg->err = ERR_VAL;
-#endif /* (LWIP_TCP || LWIP_RAW) */
     }
+#endif /* LWIP_IGMP || (LWIP_IPV6 && LWIP_IPV6_MLD) */
   }
 
 done:
